Subject: Re: [Idr] [bess] Type 1 RD for Pure IPv6 network -- EVPN

From: Muthu Arul Mozhi Perumal <[email-masked]>
Date: Wed, 3 Feb 2021 10:50:34 +0530

Hi Gyan,

Please see inline..
Regards,
Muthu

On Sat, Jan 30, 2021 at 3:26 AM Gyan Mishra <[email-masked]> wrote:

> Muthu
>
> How does RFa. 6286 AS wide BGP identifier change the BGP path selection
> process when all attributes are equal and ‘bestpath compare-routerid” is
> uses so the valid/best path is deterministic and oldest versus newest
> default.
>
The AS wide BGP identifier shouldn't change the BGP path selection process
in this case, since you compare by converting them to host byte order and
treating them as 4-octet unsigned integers as per RFC4271.

>
>
> I believe the BGP Identifier just as with OSPF or ISIS does not have to be
> routable, so in an IPv6 only network precluding RFC 6286 I believe could
> you still use a 4 octet IP address as the router-id.
>

Right. However, if we preclude RFC6286, then the BGP identifier needs to be
a valid unicast host IPv4 address (for e.g. can't be a multicast address):

<snip RFC4271>
   Syntactic correctness means that the BGP Identifier field represents
   a valid unicast IP host address.
</snip>

>
>
> This question comes up a lot these days as operations migrate to some
> flavor of IPv6 only core MPLS LDPv6, SR-MPLSv6, SRv6.
>
>
> Thanks
>
> Gyan
> On Wed, Jan 27, 2021 at 5:45 AM Muthu Arul Mozhi Perumal <
> [email-masked]> wrote:
>
>> Hi Tulasi,
>>
>> In pure IPv6 networks, I think using the BGP identifier in place of the
>> IP address part in the type 1 RD should suffice for all practical purposes.
>> The only catch is, if it is an AS-wide unique BGP identifier [RFC6286],
>> then it is not an IP address 'per se'. But, I think it makes no difference
>> from an interoperability standpoint..
>>
>> Perhaps, in line with RFC6286, we should redefine the IP address part of
>> the type 1 RD as just a 4-octet, unsigned, non-zero integer..
>>
>> Regards,
>> Muthu
>>
>> On Fri, Jan 22, 2021 at 11:31 AM TULASI RAM REDDY <
>> [email-masked]> wrote:
>>
>>> Hi All,
>>>
>>> In a pure IPv6 network, how do one expect to construct the Type 1 RD.
>>> As per EVPN RFC 7432 for EAD per ES, it should be Type 1 RD, but if the
>>> loopback address is only IPv6 then what is the expectation here?
>>> Should we use BGP router ID(32bit) here?
>>>
>>> From RFC7432: EVPN
>>>
>>> 8.2.1 <https://tools.ietf.org/html/rfc7432#section-8.2.1>.  Constructing Ethernet A-D per Ethernet Segment Route
>>>
>>>    The Route Distinguisher (RD) MUST be a Type 1 RD [RFC4364 <https://tools.ietf.org/html/rfc4364>].  The
>>>    *value field comprises an IP address of the PE (typically, the
>>>    loopback address)* followed by a number unique to the PE.
>>>
>>>
>>> Thanks,
>>> TULASI RAMI REDDY N
>>> _______________________________________________
>>> BESS mailing list
>>> [email-masked]
>>> https://www.ietf.org/mailman/listinfo/bess
>>>
>> _______________________________________________
>> Idr mailing list
>> [email-masked]
>> https://www.ietf.org/mailman/listinfo/idr
>>
> --
>
> <http://www.verizon.com/>
>
> *Gyan Mishra*
>
> *Network Solutions A**rchitect *
>
>
>
> *M 301 502-134713101 Columbia Pike *Silver Spring, MD
>
>

---

From: "Jakob Heitz (jheitz)" <[email-masked]>
Date: Wed, 3 Feb 2021 05:51:05 +0000

Why preclude RFC 6286 ?

Regards,
Jakob.

From: Idr <[email-masked]> On Behalf Of Muthu Arul Mozhi Perumal
Sent: Tuesday, February 2, 2021 9:21 PM
To: Gyan Mishra <[email-masked]>
Cc: TULASI RAM REDDY <[email-masked]>; [email-masked]; [email-masked]
Subject: Re: [Idr] [bess] Type 1 RD for Pure IPv6 network -- EVPN

Hi Gyan,

Please see inline..
Regards,
Muthu

On Sat, Jan 30, 2021 at 3:26 AM Gyan Mishra <[email-masked]<mailto:[email-masked]>> wrote:
Muthu

How does RFa. 6286 AS wide BGP identifier change the BGP path selection process when all attributes are equal and ‘bestpath compare-routerid” is uses so the valid/best path is deterministic and oldest versus newest default.
The AS wide BGP identifier shouldn't change the BGP path selection process in this case, since you compare by converting them to host byte order and treating them as 4-octet unsigned integers as per RFC4271.

I believe the BGP Identifier just as with OSPF or ISIS does not have to be routable, so in an IPv6 only network precluding RFC 6286 I believe could you still use a 4 octet IP address as the router-id.

Right. However, if we preclude RFC6286, then the BGP identifier needs to be a valid unicast host IPv4 address (for e.g. can't be a multicast address):

<snip RFC4271>

This question comes up a lot these days as operations migrate to some flavor of IPv6 only core MPLS LDPv6, SR-MPLSv6, SRv6.

Thanks

Gyan
On Wed, Jan 27, 2021 at 5:45 AM Muthu Arul Mozhi Perumal <[email-masked]<mailto:[email-masked]>> wrote:
Hi Tulasi,

In pure IPv6 networks, I think using the BGP identifier in place of the IP address part in the type 1 RD should suffice for all practical purposes. The only catch is, if it is an AS-wide unique BGP identifier [RFC6286], then it is not an IP address 'per se'. But, I think it makes no difference from an interoperability standpoint..
Perhaps, in line with RFC6286, we should redefine the IP address part of the type 1 RD as just a 4-octet, unsigned, non-zero integer..
Regards,
Muthu

On Fri, Jan 22, 2021 at 11:31 AM TULASI RAM REDDY <[email-masked]<mailto:[email-masked]>> wrote:
Hi All,

In a pure IPv6 network, how do one expect to construct the Type 1 RD.
As per EVPN RFC 7432 for EAD per ES, it should be Type 1 RD, but if the loopback address is only IPv6 then what is the expectation here?
Should we use BGP router ID(32bit) here?

From RFC7432: EVPN
8.2.1<https://tools.ietf.org/html/rfc7432#section-8.2.1>.  Constructing Ethernet A-D per Ethernet Segment Route

   The Route Distinguisher (RD) MUST be a Type 1 RD [RFC4364<https://tools.ietf.org/html/rfc4364>].  The

   value field comprises an IP address of the PE (typically, the

   loopback address) followed by a number unique to the PE.

Thanks,
TULASI RAMI REDDY N
_______________________________________________
BESS mailing list
[email-masked]<mailto:[email-masked]>
https://www.ietf.org/mailman/listinfo/bess
_______________________________________________
Idr mailing list
[email-masked]<mailto:[email-masked]>
https://www.ietf.org/mailman/listinfo/idr
--

[http://ss7.vzw.com/is/image/VerizonWireless/vz-logo-email]<http://www.verizon.com/>

Gyan Mishra

Network Solutions Architect

M 301 502-1347
13101 Columbia Pike
Silver Spring, MD

---

From: Muthu Arul Mozhi Perumal <[email-masked]>
Date: Wed, 3 Feb 2021 15:32:37 +0530

Not sure, it was just a question..will let Gyan comment if there are
devices out there that don't support RFC6286..

Regards,
Muthu

On Wed, Feb 3, 2021 at 11:21 AM Jakob Heitz (jheitz) <[email-masked]>
wrote:

> Why preclude RFC 6286 ?
>
>
>
> Regards,
>
> Jakob.
>
>
>
> *From:* Idr <[email-masked]> *On Behalf Of * Muthu Arul Mozhi
> Perumal
> *Sent:* Tuesday, February 2, 2021 9:21 PM
> *To:* Gyan Mishra <[email-masked]>
> *Cc:* TULASI RAM REDDY <[email-masked]>; [email-masked];
> [email-masked]
> *Subject:* Re: [Idr] [bess] Type 1 RD for Pure IPv6 network -- EVPN
>
>
>
> Hi Gyan,
>
>
>
> Please see inline..
>
> Regards,
>
> Muthu
>
>
>
> Right. However, if we preclude RFC6286, then the BGP identifier needs to
> be a valid unicast host IPv4 address (for e.g. can't be a multicast
> address):
>
>
>
> <snip RFC4271>
>
> In pure IPv6 networks, I think using the BGP identifier in place of the IP
> address part in the type 1 RD should suffice for all practical purposes.
>    *value field comprises an IP address of the PE (typically, the*
>
> *   loopback address)* followed by a number unique to the PE.
>
>
>
> Thanks,
>
> TULASI RAMI REDDY N
>
> *Network Solutions Architect *
>
>
>
> *M 301 502-1347 13101 Columbia Pike  *Silver Spring, MD
>
>
>
>

---

From: Gyan Mishra <[email-masked]>
Date: Wed, 3 Feb 2021 09:03:44 -0500

Hi Muthu

Please see in-line

> treating them as 4-octet unsigned integers as per RFC4271.

    Gyan> So with RFC 6286 the 4 octet unsigned could be any number from 1
to 4.2 billion.  I see in the remarks that the BGP identifier is to use RFC
4271 process for path selection resolution.

     In the route selection, where the BGP Identifier is not used in
     comparing a route from an internal neighbor and a route from an
     external neighbor.  In addition, routes from BGP speakers with
     identical BGP Identifiers have been dealt with (e.g., parallel BGP
     sessions between two BGP speakers).

When you are comparing two paths with the same router-id and you convert to
host byte order and treat as unsigned integer per RFC 4271 can you give an
example of how that would work.  I am not following the verbiage.  If the
BGP identifier is the same AS wide would the host byte order be the same
for each BGP speaker?

         The BGP Identifier of the local system is compared to the BGP
         Identifier of the remote system (as specified in the OPEN
         message).  Comparing BGP Identifiers is done by converting them
         to host byte order and treating them as 4-octet unsigned
         integers.

>
>>
>> I believe the BGP Identifier just as with OSPF or ISIS does not have to
>> be routable, so in an IPv6 only network precluding RFC 6286 I believe could
     Gyan> I do see that verbiage in section 6.2

   If the BGP Identifier field of the OPEN message is syntactically
   incorrect, then the Error Subcode MUST be set to Bad BGP Identifier.
   Syntactic correctness means that the BGP Identifier field represents
   a valid unicast IP host address.

BGP with IGP call back NH tracker checks the NH but how does BGP code
validate the RIB that the router-id is a connected loopback but

and also advertised by IGP.  I have not tried it but if you set a
bogus router-id would all the BGP peers go down.

I will try that in the lab.

>> *M 301 502-134713101 Columbia Pike
>> <https://www.google.com/maps/search/13101+Columbia+Pike?entry=gmail&source=g> *Silver
>> Spring, MD
>>
>> --

*Gyan Mishra*

---

From: "Jakob Heitz (jheitz)" <[email-masked]>
Date: Thu, 4 Feb 2021 04:22:25 +0000

<snip RFC4271>

BGP with IGP call back NH tracker checks the NH but how does BGP code validate the RIB that the router-id is a connected loopback but

and also advertised by IGP.  I have not tried it but if you set a bogus router-id would all the BGP peers go down.

IOS-XR does not have this check. Nothing breaks by violating this rule. IOS-XR implements RFC 6286.
I think you'll be hard pressed to find a router that checks this.

Regards,
Jakob.

---

From: Gyan Mishra <[email-masked]>
Date: Thu, 4 Feb 2021 00:41:35 -0500

On Wed, Feb 3, 2021 at 11:22 PM Jakob Heitz (jheitz) <[email-masked]>
wrote:

>  Gyan> Agreed.  That is exactly what I thought.  I was going to try on IOS
> XR but you saved me some time and results as I expected.  I will try test
> RFC 6286 on XR.  Have you tried doing IPv6 only peers on XR and with BGP
> identifier set unique to 4 octet IP address and see if that works.  I am
> guessing it would work as XR does not have the check.
>

    I  am not crazy about the RFC 6286 AS wide BGP identifier with 4 octet
unsigned non zero integer.  Most operators are more comfortable having
unique 4 octet IP address as BGP identifier and I think would much rather
do that as long as the check does not exist as even with enabling RFC 6286
and having AS wide unique identifier seems odd and scary to me as normally
the BGP identifier must always be unique within the domain or breaks BGP.

dual stack edge over v6 core RFC 5565 is becoming more common for operators
every day with SRv6 push and thus IPv6 only routers and running into this
issue where now you have to enable RFC 6286.

I am thinking it maybe well worthwhile to write a draft that updates RFC
4271 check as vendors don’t follow it anyway and as we all know not
checking is not going to break anything and making so that for IPv6 only
routers such as in a SRv6 core that the BGP identifier can remain a 4 octet
IP and then operators now could keep the same unique BGP identifier IP you
had on the router before you ripped it out of the core when transitioned to
SRv6.

-- 

*Gyan Mishra*

---

From: "Jakob Heitz (jheitz)" <[email-masked]>
Date: Thu, 4 Feb 2021 05:51:24 +0000

RFC 6286 already updates RFC 4271.
Basically, RID is not unique. (ASN,RID) is unique. The only limitation on RID is that RID != 0.

Regards,
Jakob.

From: Gyan Mishra <[email-masked]>
Sent: Wednesday, February 3, 2021 9:42 PM
To: Jakob Heitz (jheitz) <[email-masked]>
Cc: Muthu Arul Mozhi Perumal <[email-masked]>; TULASI RAM REDDY <[email-masked]>; [email-masked]; [email-masked]
Subject: Re: [Idr] [bess] Type 1 RD for Pure IPv6 network -- EVPN

On Wed, Feb 3, 2021 at 11:22 PM Jakob Heitz (jheitz) <[email-masked]<mailto:[email-masked]>> wrote:
<snip RFC4271>
   Syntactic correctness means that the BGP Identifier field represents
   a valid unicast IP host address.
</snip>

IOS-XR does not have this check. Nothing breaks by violating this rule. IOS-XR implements RFC 6286.
I think you'll be hard pressed to find a router that checks this.
 Gyan> Agreed.  That is exactly what I thought.  I was going to try on IOS XR but you saved me some time and results as I expected.  I will try test RFC 6286 on XR.  Have you tried doing IPv6 only peers on XR and with BGP identifier set unique to 4 octet IP address and see if that works.  I am guessing it would work as XR does not have the check.

    I  am not crazy about the RFC 6286 AS wide BGP identifier with 4 octet unsigned non zero integer.  Most operators are more comfortable having unique 4 octet IP address as BGP identifier and I think would much rather do that as long as the check does not exist as even with enabling RFC 6286 and having AS wide unique identifier seems odd and scary to me as normally the BGP identifier must always be unique within the domain or breaks BGP.

dual stack edge over v6 core RFC 5565 is becoming more common for operators every day with SRv6 push and thus IPv6 only routers and running into this issue where now you have to enable RFC 6286.

I am thinking it maybe well worthwhile to write a draft that updates RFC 4271 check as vendors don’t follow it anyway and as we all know not checking is not going to break anything and making so that for IPv6 only routers such as in a SRv6 core that the BGP identifier can remain a 4 octet IP and then operators now could keep the same unique BGP identifier IP you had on the router before you ripped it out of the core when transitioned to SRv6.
Regards,
Jakob.

--

Gyan Mishra

M 301 502-1347
13101 Columbia Pike
Silver Spring, MD

---

From: "Acee Lindem (acee)" <[email-masked]>
Date: Thu, 4 Feb 2021 11:09:23 +0000

Hi Gyan,
Agree with Jakob. There is no reason for the BGP Identifier to be a unique IPv4 address. Consider an IPv6 only AS. However, there is nothing precluding you from using an IPv4 address if you are uncomfortable.

Thanks,
Acee

From: BESS <[email-masked]> on behalf of "Jakob Heitz (jheitz)" <jheitz=[email-masked]>
Date: Thursday, February 4, 2021 at 12:52 AM
To: Gyan Mishra <[email-masked]>
Cc: TULASI RAM REDDY <[email-masked]>, Muthu Arul Mozhi Perumal <[email-masked]>, "[email-masked]" <[email-masked]>, IDR List <[email-masked]>
Subject: Re: [bess] [Idr] Type 1 RD for Pure IPv6 network -- EVPN

Regards,
Jakob.

--

[Image removed by sender.]<http://www.verizon.com/>

Gyan Mishra

M 301 502-1347
13101 Columbia Pike
Silver Spring, MD

---

From: TULASI RAM REDDY <[email-masked]>
Date: Thu, 4 Feb 2021 19:23:36 +0530

Hi All,

So, we can also assume the below "IP address of the PE" requirement for
Type 1 RD of EAD per AS
is not true in pure IPv6 only AS.
This should be read as any AS wide unique 4-octet, unsigned, non-zero
integer (similar to RFC6286).

>From RFC7432: EVPN

8.2.1 <https://tools.ietf.org/html/rfc7432#section-8.2.1>.
Constructing Ethernet A-D per Ethernet Segment Route

   The Route Distinguisher (RD) MUST be a Type 1 RD [RFC4364
<https://tools.ietf.org/html/rfc4364>].  The
   *value field comprises an* IP address of the PE *(typically, the
   loopback address)* followed by a number unique to the PE.

Thanks,
Tulasi.

On Thu, Feb 4, 2021 at 4:39 PM Acee Lindem (acee) <[email-masked]> wrote:

> Hi Gyan,
>
> Agree with Jakob. There is no reason for the BGP Identifier to be a unique
> IPv4 address. Consider an IPv6 only AS. However, there is nothing
> precluding you from using an IPv4 address if you are uncomfortable.
>
>
>
> Thanks,
> Acee
>
>
>
> *From: *BESS <[email-masked]> on behalf of "Jakob Heitz (jheitz)"
> <jheitz=[email-masked]>
> *Date: *Thursday, February 4, 2021 at 12:52 AM
> *To: *Gyan Mishra <[email-masked]>
> *Cc: *TULASI RAM REDDY <[email-masked]>, Muthu Arul Mozhi
> Perumal <[email-masked]>, "[email-masked]" <[email-masked]>, IDR List
> <[email-masked]>
> *Subject: *Re: [bess] [Idr] Type 1 RD for Pure IPv6 network -- EVPN
>
>
>
> *From:* Gyan Mishra <[email-masked]>
> *Sent:* Wednesday, February 3, 2021 9:42 PM
> *To:* Jakob Heitz (jheitz) <[email-masked]>
> *Cc:* Muthu Arul Mozhi Perumal <[email-masked]>; TULASI RAM REDDY <
> [email-masked]>; [email-masked]; [email-masked]
> dual stack edge over v6 core RFC 5565 is becoming more common for
> operators every day with SRv6 push and thus IPv6 only routers and running
> into this issue where now you have to enable RFC 6286.
>
>
>

-- 
TULASI RAMI REDDY N

---

From: Gyan Mishra <[email-masked]>
Date: Thu, 4 Feb 2021 09:55:18 -0500

Hi Acee

Understood the uniqueness by ASN,RID per RFC 6286 AS wide BGP identifier
for the IPv6 only SRv6 core use case.

What I am uncomfortable as an operator with is the AS wide BGP identifier
on every core router using the RFC 6286 knob for the SRv6 use case.  If we
could continue to use unique IPv4 address  on every core router in the SRv6
IPv6 only core use case I would be more comfortable then using the RFC 6286
knob.

Kind Regards

Gyan

On Thu, Feb 4, 2021 at 6:09 AM Acee Lindem (acee) <[email-masked]> wrote:

> *M 301 502-1347 13101 Columbia Pike
> <https://www.google.com/maps/search/13101+Columbia+Pike?entry=gmail&source=g>
> *Silver Spring, MD
>
>
>
-- 

*Gyan Mishra*

---

From: "Jakob Heitz (jheitz)" <[email-masked]>
Date: Thu, 4 Feb 2021 16:15:52 +0000

There's no knob for RFC 6286. RID cannot be assumed to be unique across ASes. Period. Well, unless you have control over all the ASes. What do you mean by the knob exactly?

Regards,
Jakob.

On Feb 4, 2021, at 6:55 AM, Gyan Mishra <[email-masked]> wrote:

Hi Acee

Understood the uniqueness by ASN,RID per RFC 6286 AS wide BGP identifier for the IPv6 only SRv6 core use case.

What I am uncomfortable as an operator with is the AS wide BGP identifier on every core router using the RFC 6286 knob for the SRv6 use case.  If we could continue to use unique IPv4 address  on every core router in the SRv6 IPv6 only core use case I would be more comfortable then using the RFC 6286 knob.

Kind Regards

Gyan

On Thu, Feb 4, 2021 at 6:09 AM Acee Lindem (acee) <[email-masked]<mailto:[email-masked]>> wrote:
Hi Gyan,
Agree with Jakob. There is no reason for the BGP Identifier to be a unique IPv4 address. Consider an IPv6 only AS. However, there is nothing precluding you from using an IPv4 address if you are uncomfortable.

Thanks,
Acee

From: BESS <[email-masked]<mailto:[email-masked]>> on behalf of "Jakob Heitz (jheitz)" <jheitz=[email-masked]<mailto:[email-masked]>>
Date: Thursday, February 4, 2021 at 12:52 AM
To: Gyan Mishra <[email-masked]<mailto:[email-masked]>>
Cc: TULASI RAM REDDY <[email-masked]<mailto:[email-masked]>>, Muthu Arul Mozhi Perumal <[email-masked]<mailto:[email-masked]>>, "[email-masked]<mailto:[email-masked]>" <[email-masked]<mailto:[email-masked]>>, IDR List <[email-masked]<mailto:[email-masked]>>
Subject: Re: [bess] [Idr] Type 1 RD for Pure IPv6 network -- EVPN

Regards,
Jakob.

From: Gyan Mishra <[email-masked]<mailto:[email-masked]>>
Sent: Wednesday, February 3, 2021 9:42 PM
To: Jakob Heitz (jheitz) <[email-masked]<mailto:[email-masked]>>
Cc: Muthu Arul Mozhi Perumal <[email-masked]<mailto:[email-masked]>>; TULASI RAM REDDY <[email-masked]<mailto:[email-masked]>>; [email-masked]<mailto:[email-masked]>; [email-masked]<mailto:[email-masked]>
Subject: Re: [Idr] [bess] Type 1 RD for Pure IPv6 network -- EVPN

--

Gyan Mishra

M 301 502-1347
13101 Columbia Pike<https://www.google.com/maps/search/13101+Columbia+Pike?entry=gmail&source=g>
Silver Spring, MD

--

Gyan Mishra

M 301 502-1347
13101 Columbia Pike
Silver Spring, MD

---

From: Gyan Mishra <[email-masked]>
Date: Thu, 4 Feb 2021 19:23:31 -0500

I was thinking a CLI knob but RFC 6286 updates RFC 4271 which sounds like
new default behavior change with a upgrade.

Kind Regards

Gyan

On Thu, Feb 4, 2021 at 11:16 AM Jakob Heitz (jheitz) <[email-masked]>
wrote:

> There's no knob for RFC 6286. RID cannot be assumed to be unique across
> ASes. Period. Well, unless you have control over all the ASes. What do you
> mean by the knob exactly?
>
> Regards,
> Jakob.
>
>
>> Agree with Jakob. There is no reason for the BGP Identifier to be a
>> unique IPv4 address. Consider an IPv6 only AS. However, there is nothing
>> Perumal <[email-masked]>, "[email-masked]" <[email-masked]>, IDR
>> List <[email-masked]>
>>  Gyan> Agreed.  That is exactly what I thought.  I was going to try on
>> IOS XR but you saved me some time and results as I expected.  I will try
>> test RFC 6286 on XR.  Have you tried doing IPv6 only peers on XR and with
>> BGP identifier set unique to 4 octet IP address and see if that works.  I
>> am guessing it would work as XR does not have the check.
>>
>>
>>
>>     I  am not crazy about the RFC 6286 AS wide BGP identifier with 4
>> octet unsigned non zero integer.  Most operators are more comfortable
>> having unique 4 octet IP address as BGP identifier and I think would much
>> rather do that as long as the check does not exist as even with enabling
>> RFC 6286 and having AS wide unique identifier seems odd and scary to me as
>> normally the BGP identifier must always be unique within the domain or
>> breaks BGP.
>>
>>
>>

*Gyan Mishra*